unit spl_bzip2;

interface

uses
  Windows,
  spl_com,
  winliblt;

const
  SAL_BZ_RUN = 0;
  SAL_BZ_FLUSH = 1;
  SAL_BZ_FINISH = 2;
  
  SAL_BZ_OK = 0;
  SAL_BZ_RUN_OK = 1;
  SAL_BZ_FLUSH_OK = 2;
  SAL_BZ_FINISH_OK = 3;
  SAL_BZ_STREAM_END = 4;
  SAL_BZ_SEQUENCE_ERROR = -1;
  SAL_BZ_PARAM_ERROR = -2;
  SAL_BZ_MEM_ERROR = -3;
  SAL_BZ_DATA_ERROR = -4;
  SAL_BZ_DATA_ERROR_MAGIC = -5;
  SAL_BZ_IO_ERROR = -6;
  SAL_BZ_UNEXPECTED_EOF = -7;
  SAL_BZ_OUTBUFF_FULL = -8;
  SAL_BZ_CONFIG_ERROR = -9;

type
  TSalBZIP2 = packed record
   next_in: PBYTE;
   avail_in: UINT;
   total_in: TQuadWord;
   next_out: PBYTE;
   avail_out: UINT;
   total_out: TQuadWord;
   internal: Pointer;
  end;
  PSalBZIP2 = ^TSalBZIP2;

  TSalamanderBZIP2Abstract = class
    function CompressInit(bzip2Info: PSalBZIP2; blockSize100k: Integer; workFactor: Integer): Integer; virtual; stdcall; abstract;
    function Compress(bzip2Info: PSalBZIP2; action: Integer): Integer; virtual; stdcall; abstract;
    function CompressEnd(bzip2Info: PSalBZIP2): Integer; virtual; stdcall; abstract;
    function DecompressInit(bzip2Info: PSalBZIP2; bConserveMemory: BOOL): Integer; virtual; stdcall; abstract;
    function Decompress(bzip2Info: PSalBZIP2): Integer; virtual; stdcall; abstract;
    function DecompressEnd(bzip2Info: PSalBZIP2): Integer; virtual; stdcall; abstract;
  end;

implementation

end.
