unit spl_file;

interface

uses
  Windows;

const
  HWND_STORED = -1;

  SAFE_FILE_CHECK_SIZE = $00010000;

  SILENT_SKIP_FILE_NAMEUSED = $00000001;
  SILENT_SKIP_DIR_NAMEUSED = $00000002;
  SILENT_SKIP_FILE_CREATE = $00000004;
  SILENT_SKIP_DIR_CREATE = $00000008;
  SILENT_SKIP_FILE_EXIST = $00000010;
  SILENT_SKIP_FILE_SYSHID = $00000020;
  SILENT_SKIP_FILE_READ = $00000040;
  SILENT_SKIP_FILE_WRITE = $00000080;
  SILENT_SKIP_FILE_OPEN = $00000100;

  SILENT_OVERWRITE_FILE_EXIST = $00001000;
  SILENT_OVERWRITE_FILE_SYSHID = $00002000;

  SILENT_RESERVED_FOR_PLUGINS = $FFFF0000;

type
  SAFE_FILE = packed record
    HFile: THandle;
    FileName: PAnsiChar;
    HParentWnd: HWND;
    dwDesiredAccess: DWORD;
    dwShareMode: DWORD;
    dwCreationDisposition: DWORD;
    dwFlagsAndAttributes: DWORD;
    WholeFileAllocated: BOOL;
  end;
  PSAFE_FILE = ^SAFE_FILE;

  TSalamanderSafeFileAbstract = class
    function SafeFileOpen(_file: PSAFE_FILE; fileName: PAnsiChar; dwDesiredAccess: DWORD; dwShareMode: DWORD; dwCreationDisposition: DWORD; dwFlagsAndAttributes: DWORD; hParent: HWND; flags: DWORD; pressedButton: PDWORD; silentMask: PDWORD): BOOL; virtual; stdcall; abstract;
    function SafeFileCreate(fileName: PAnsiChar; dwDesiredAccess: DWORD; dwShareMode: DWORD; dwFlagsAndAttributes: DWORD; isDir: BOOL; hParent: HWND; srcFileName: PAnsiChar; srcFileInfo: PAnsiChar; silentMask: PDWORD; allowSkip: BOOL; skipped: PBOOL; skipPath: PAnsiChar; skipPathMax: Integer; allocateWholeFile: PLargeInteger; _file: PSAFE_FILE): THandle; virtual; stdcall; abstract;
    procedure SafeFileClose(_file: PSAFE_FILE); virtual; stdcall; abstract;
    function SafeFileSeek(_file: PSAFE_FILE; distance: PLargeInteger; moveMethod: DWORD; error: PDWORD): BOOL; virtual; stdcall; abstract;
    function SafeFileGetSize(_file: PSAFE_FILE; fileSize: PLargeInteger; error: PDWORD): BOOL; virtual; stdcall; abstract;
    function SafeFileRead(_file: PSAFE_FILE; lpBuffer: Pointer; nNumberOfBytesToRead: DWORD; lpNumberOfBytesRead: PDWORD; hParent: HWND; flags: DWORD; pressedButton: PDWORD; silentMask: PDWORD): BOOL; virtual; stdcall; abstract;
    function SafeFileWrite(_file: PSAFE_FILE; lpBuffer: Pointer; nNumberOfBytesToWrite: DWORD; lpNumberOfBytesWritten: PDWORD; hParent: HWND; flags: DWORD; pressedButton: PDWORD; silentMask: PDWORD): BOOL; virtual; stdcall; abstract;
  end;

implementation

end.
