unit spl_gen;

interface

uses
  Windows,
  CommDlg,
  winliblt,
  spl_com,
  spl_fs,
  spl_crypt,
  spl_zlib,
  spl_bzip2;

const
  MSGBOX_INFO = 0;
  MSGBOX_ERROR = 1;
  MSGBOX_EX_ERROR = 2;
  MSGBOX_QUESTION = 3;
  MSGBOX_EX_QUESTION = 4;
  MSGBOX_WARNING = 5;
  MSGBOX_EX_WARNING = 6;

  MSGBOXEX_OK = $00000000;
  MSGBOXEX_OKCANCEL = $00000001;
  MSGBOXEX_ABORTRETRYIGNORE = $00000002;
  MSGBOXEX_YESNOCANCEL = $00000003;
  MSGBOXEX_YESNO = $00000004;
  MSGBOXEX_RETRYCANCEL = $00000005;
  MSGBOXEX_CANCELTRYCONTINUE = $00000006;
  MSGBOXEX_CONTINUEABORT = $00000007;

  MSGBOXEX_ICONHAND = $00000010;
  MSGBOXEX_ICONQUESTION = $00000020;
  MSGBOXEX_ICONEXCLAMATION = $00000030;
  MSGBOXEX_ICONINFORMATION = $00000040;

  MSGBOXEX_DEFBUTTON1 = $00000000;
  MSGBOXEX_DEFBUTTON2 = $00000100;
  MSGBOXEX_DEFBUTTON3 = $00000200;
  MSGBOXEX_DEFBUTTON4 = $00000300;

  MSGBOXEX_HELP = $00004000;

  MSGBOXEX_SETFOREGROUND = $00010000;

  MSGBOXEX_SILENT = $10000000;
  MSGBOXEX_ESCAPEENABLED = $20000000;
  MSGBOXEX_HINT = $40000000;

  MSGBOXEX_TYPEMASK = $0000000F;
  MSGBOXEX_ICONMASK = $000000F0;
  MSGBOXEX_DEFMASK = $00000F00;
  MSGBOXEX_MODEMASK = $00003000;
  MSGBOXEX_MISCMASK = $0000C000;
  MSGBOXEX_EXMASK = $F0000000;

  DIALOG_FAIL = $00000000;
  DIALOG_OK = $00000001;
  DIALOG_CANCEL = $00000002;
  DIALOG_ABORT = $00000003;
  DIALOG_RETRY = $00000004;
  DIALOG_IGNORE = $00000005;
  DIALOG_YES = $00000006;
  DIALOG_NO = $00000007;
  DIALOG_TRYAGAIN = $0000000a;
  DIALOG_CONTINUE = $0000000b;
  DIALOG_SKIP = $10000000;
  DIALOG_SKIPALL = $20000000;
  DIALOG_ALL = $30000000;

  PANEL_SOURCE = 1;
  PANEL_TARGET = 2;
  PANEL_LEFT = 3;
  PANEL_RIGHT = 4;

  PATH_TYPE_WINDOWS = 1;
  PATH_TYPE_ARCHIVE = 2;
  PATH_TYPE_FS = 3;

  BUTTONS_OK = $00000000;
  BUTTONS_RETRYCANCEL = $00000001;
  BUTTONS_SKIPCANCEL = $00000002;
  BUTTONS_RETRYSKIPCANCEL = $00000003;
  BUTTONS_YESALLSKIPCANCEL = $00000004;
  BUTTONS_YESNOCANCEL = $00000005;
  BUTTONS_YESALLCANCEL = $00000006;
  BUTTONS_MASK = $000000FF;

  GFN_SERVERNAMEMISSING = 1;
  GFN_SHARENAMEMISSING = 2;
  GFN_TOOLONGPATH = 3;
  GFN_INVALIDDRIVE = 4;
  GFN_INCOMLETEFILENAME = 5;
  GFN_EMPTYNAMENOTALLOWED = 6;
  GFN_PATHISINVALID = 7;

  ERROR_USER_TERMINATED = -100;

  PATH_MAX_PATH = 248;

  SPP_EMPTYPATHNOTALLOWED = 1;
  SPP_WINDOWSPATHERROR = 2;
  SPP_NOTARCHIVEFILE = 3;
  SPP_NOTPLUGINFS = 4;
  SPP_INCOMLETEPATH = 5;

  SALCOL_FOCUS_ACTIVE_NORMAL = 0;                                               
  SALCOL_FOCUS_ACTIVE_SELECTED = 1;
  SALCOL_FOCUS_FG_INACTIVE_NORMAL = 2;
  SALCOL_FOCUS_FG_INACTIVE_SELECTED = 3;
  SALCOL_FOCUS_BK_INACTIVE_NORMAL = 4;
  SALCOL_FOCUS_BK_INACTIVE_SELECTED = 5;
  SALCOL_ITEM_FG_NORMAL = 6;
  SALCOL_ITEM_FG_SELECTED = 7;
  SALCOL_ITEM_FG_FOCUSED = 8;
  SALCOL_ITEM_FG_FOCSEL = 9;
  SALCOL_ITEM_FG_HIGHLIGHT = 10;
  SALCOL_ITEM_BK_NORMAL = 11;
  SALCOL_ITEM_BK_SELECTED = 12;
  SALCOL_ITEM_BK_FOCUSED = 13;
  SALCOL_ITEM_BK_FOCSEL = 14;
  SALCOL_ITEM_BK_HIGHLIGHT = 15;
  SALCOL_ICON_BLEND_SELECTED = 16;
  SALCOL_ICON_BLEND_FOCUSED = 17;
  SALCOL_ICON_BLEND_FOCSEL = 18;
  SALCOL_PROGRESS_FG_NORMAL = 19;
  SALCOL_PROGRESS_FG_SELECTED = 20;
  SALCOL_PROGRESS_BK_NORMAL = 21;
  SALCOL_PROGRESS_BK_SELECTED = 22;
  SALCOL_HOT_PANEL = 23;
  SALCOL_HOT_ACTIVE = 24;
  SALCOL_HOT_INACTIVE = 25;
  SALCOL_ACTIVE_CAPTION_FG = 26;
  SALCOL_ACTIVE_CAPTION_BK = 27;
  SALCOL_INACTIVE_CAPTION_FG = 28;
  SALCOL_INACTIVE_CAPTION_BK = 29;
  SALCOL_VIEWER_FG_NORMAL = 30;
  SALCOL_VIEWER_BK_NORMAL = 31;
  SALCOL_VIEWER_FG_SELECTED = 32;
  SALCOL_VIEWER_BK_SELECTED = 33;
  SALCOL_THUMBNAIL_NORMAL = 34;
  SALCOL_THUMBNAIL_SELECTED = 35;
  SALCOL_THUMBNAIL_FOCUSED = 36;
  SALCOL_THUMBNAIL_FOCSEL = 37;

  CHPPFR_SUCCESS = 0;
  CHPPFR_INVALIDPATH = 1;
  CHPPFR_INVALIDARCHIVE = 2;
  CHPPFR_LOWMEMORY = 3;
  CHPPFR_CANNOTCLOSEPATH = 4;
  CHPPFR_SHORTERPATH = 5;
  CHPPFR_FILENAMEFOCUSED = 6;

  SALCFGTYPE_NOTFOUND = 0;
  SALCFGTYPE_BOOL = 1;
  SALCFGTYPE_INT = 2;
  SALCFGTYPE_STRING = 3;
  SALCFGTYPE_LOGFONT = 4;

  SALCFG_SELOPINCLUDEDIRS = 1;
  SALCFG_SAVEONEXIT = 2;
  SALCFG_MINBEEPWHENDONE = 3;
  SALCFG_HIDEHIDDENORSYSTEMFILES = 4;
  SALCFG_USEOPENNOTEXPLORE = 5;
  SALCFG_ALWAYSONTOP = 6;
  SALCFG_SORTUSESLOCALE = 7;
  SALCFG_SINGLECLICK = 8;
  SALCFG_TOPTOOLBARVISIBLE = 9;
  SALCFG_BOTTOMTOOLBARVISIBLE = 10;
  SALCFG_USERMENUTOOLBARVISIBLE = 11;
  SALCFG_INFOLINECONTENT = 12;
  SALCFG_FILENAMEFORMAT = 13;
  SALCFG_SAVEHISTORY = 14;
  SALCFG_ENABLECMDLINEHISTORY = 15;
  SALCFG_SAVECMDLINEHISTORY = 16;
  SALCFG_MIDDLETOOLBARVISIBLE = 17;
  SALCFG_SORTDETECTNUMBERS = 18;
  SALCFG_SORTBYEXTDIRSASFILES = 19;
  SALCFG_SIZEFORMAT = 20;
  SALCFG_SELECTWHOLENAME = 21;
  SALCFG_USERECYCLEBIN = 50;
  SALCFG_RECYCLEBINMASKS = 51;
  SALCFG_COMPDIRSUSETIMERES = 60;
  SALCFG_COMPDIRTIMERES = 61;
  SALCFG_CNFRMFILEDIRDEL = 70;
  SALCFG_CNFRMNEDIRDEL = 71;
  SALCFG_CNFRMFILEOVER = 72;
  SALCFG_CNFRMSHFILEDEL = 73;
  SALCFG_CNFRMSHDIRDEL = 74;
  SALCFG_CNFRMSHFILEOVER = 75;
  SALCFG_CNFRMCREATEPATH = 76;
  SALCFG_CNFRMDIROVER = 77;
  SALCFG_DRVSPECFLOPPYMON = 88;
  SALCFG_DRVSPECFLOPPYSIM = 89;
  SALCFG_DRVSPECREMOVABLEMON = 90;
  SALCFG_DRVSPECREMOVABLESIM = 91;
  SALCFG_DRVSPECFIXEDMON = 92;
  SALCFG_DRVSPECFIXEDSIMPLE = 93;
  SALCFG_DRVSPECREMOTEMON = 94;
  SALCFG_DRVSPECREMOTESIMPLE = 95;
  SALCFG_DRVSPECREMOTEDONOTREF = 96;
  SALCFG_DRVSPECCDROMMON = 97;
  SALCFG_DRVSPECCDROMSIMPLE = 98;
  SALCFG_IFPATHISINACCESSIBLEGOTO = 99;
  SALCFG_VIEWEREOLCRLF = 120;
  SALCFG_VIEWEREOLCR = 121;
  SALCFG_VIEWEREOLLF = 122;
  SALCFG_VIEWEREOLNULL = 123;
  SALCFG_VIEWERTABSIZE = 124;
  SALCFG_VIEWERSAVEPOSITION = 125;
  SALCFG_VIEWERFONT = 126;
  SALCFG_VIEWERWRAPTEXT = 127;
  SALCFG_ARCOTHERPANELFORPACK = 140;
  SALCFG_ARCOTHERPANELFORUNPACK = 141;
  SALCFG_ARCSUBDIRBYARCFORUNPACK = 142;
  SALCFG_ARCUSESIMPLEICONS = 143;

  SASF_CASESENSITIVE = $01;
  SASF_FORWARD = $02;

  SALICON_EXECUTABLE = 1;
  SALICON_DIRECTORY = 2;
  SALICON_NONASSOCIATED = 3;
  SALICON_ASSOCIATED = 4;
  SALICON_UPDIR = 5;
  SALICON_ARCHIVE = 6;

  SALICONSIZE_16 = 1;
  SALICONSIZE_32 = 2;
  SALICONSIZE_48 = 3;

  sctyUnknown = 0;
  sctyForFocusedFile = 1;
  sctyForFocusedFileOrDirectory = 2;
  sctyForSelectedFilesAndDirectories = 3;
  sctyForCurrentPath = 4;
  sctyForConnectedDrivesAndFS = 5;

  SALCMD_VIEW = 0;
  SALCMD_ALTVIEW = 1;
  SALCMD_VIEWWITH = 2;
  SALCMD_EDIT = 3;
  SALCMD_EDITWITH = 4;
  SALCMD_OPEN = 20;
  SALCMD_QUICKRENAME = 21;
  SALCMD_COPY = 40;
  SALCMD_MOVE = 41;
  SALCMD_EMAIL = 42;
  SALCMD_DELETE = 43;
  SALCMD_PROPERTIES = 44;
  SALCMD_CHANGECASE = 45;
  SALCMD_CHANGEATTRS = 46;
  SALCMD_OCCUPIEDSPACE = 47;
  SALCMD_EDITNEWFILE = 70;
  SALCMD_REFRESH = 71;
  SALCMD_CREATEDIRECTORY = 72;
  SALCMD_DRIVEINFO = 73;
  SALCMD_CALCDIRSIZES = 74;
  SALCMD_DISCONNECT = 90;

  MAX_GROUPMASK = 1001;

  SALHIST_QUICKRENAME = 1;
  SALHIST_COPYMOVETGT = 2;
  SALHIST_CREATEDIR = 3;
  SALHIST_CHANGEDIR = 4;
  SALHIST_EDITNEW = 5;
  SALHIST_CONVERT = 6;

  epfdmNormal = 0;
  epfdmSelected = 1;
  epfdmHidden = 2;

  WINDOWS_VERSION_95 = 1;
  WINDOWS_VERSION_95_AND_LATER = 2;
  WINDOWS_VERSION_95OSR2_AND_LATER = 3;
  WINDOWS_VERSION_98_AND_LATER = 4;
  WINDOWS_VERSION_ME_AND_LATER = 5;

  WINDOWS_VERSION_NT_AND_LATER = 20;
  WINDOWS_VERSION_2000_AND_LATER = 21;
  WINDOWS_VERSION_XP_AND_LATER = 22;
  WINDOWS_VERSION_VISTA_AND_LATER = 23;
  WINDOWS_VERSION_7_AND_LATER = 24;

type
  TMsgBoxExCallback = procedure(helpInfo: PHelpInfo); stdcall;

  TMsgBoxExParams = packed record
    HParent: HWND;
    Text: PAnsiChar;
    Caption: PAnsiChar;
    Flags: DWORD;
    HIcon: HICON;
    ContextHelpId: DWORD;
    HelpCallback: TMsgBoxExCallback;
    CheckBoxText: PAnsiChar;
    CheckBoxValue: PBOOL;
    AliasBtnNames: PAnsiChar;
  end;
  PMsgBoxExParams = ^TMsgBoxExParams;

  TSalamanderVarStrGetValueFunc = function(msgParent: HWND; param: Pointer): PAnsiChar; stdcall;

  TSalamanderVarStrEntry = packed record
    Name: PAnsiChar;
    Execute: TSalamanderVarStrGetValueFunc;
  end;
  PSalamanderVarStrEntry = ^TSalamanderVarStrEntry;

  TSalLoadOrSaveConfigurationProc = procedure(load: BOOL; regKey: HKEY; registry: TSalamanderRegistryAbstract; param: Pointer); stdcall;

  TSalamanderPluginViewerData = packed record
    Size: Integer;
    FileName: PAnsiChar;
  end;
  PSalamanderPluginViewerData = ^TSalamanderPluginViewerData;

  TSalamanderPluginInternalViewerData = packed record
    Mode: Integer;
    Caption: PAnsiChar;
    WholeCaption: BOOL;
  end;

  TSGP_IsTheSamePathFunc = function(path1: PAnsiChar; path2: PAnsiChar): BOOL; stdcall;

  TSalPluginOperationFromDiskProc = procedure(sourcePath: PAnsiChar; next: TSalEnumSelection2Func; nextParam: Pointer; param: Pointer); stdcall;

  TSalamanderBMSearchData = class
    procedure Set_(pattern: PAnsiChar; flags: Word); overload; virtual; stdcall; abstract;
    procedure Set_(pattern: PAnsiChar; length: Integer; flags: Word); overload; virtual; stdcall; abstract;
    procedure SetFlags(flags: Word); virtual; stdcall; abstract;
    function GetLength: Integer; virtual; stdcall; abstract;
    function GetPattern: PAnsiChar; virtual; stdcall; abstract;
    function IsGood: BOOL; virtual; stdcall; abstract;
    function SearchForward(text: PAnsiChar; length: Integer; start: Integer): Integer; virtual; stdcall; abstract;
    function SearchBackward(text: PAnsiChar; length: Integer): Integer; virtual; stdcall; abstract;
  end;

  TSalamanderREGEXPSearchData = class
    function Set_(pattern: PAnsiChar; flags: Word): BOOL; virtual; stdcall; abstract;
    function SetFlags(flags: Word): BOOL; virtual; stdcall; abstract;
    function GetLastErrorText: PAnsiChar; virtual; stdcall; abstract;
    function GetPattern: PAnsiChar; virtual; stdcall; abstract;
    function SetLine(start: PAnsiChar; _end: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function SearchForward(start: Integer; var foundLen: Integer): Integer; virtual; stdcall; abstract;
    function SearchBackward(length: Integer; var foundLen: Integer): Integer; virtual; stdcall; abstract;
  end;

  TSalamanderMaskGroup = class
    procedure SetMasksString(masks: PAnsiChar; extendedMode: BOOL); virtual; stdcall; abstract;
    procedure GetMasksString(buffer: PAnsiChar); virtual; stdcall; abstract;
    function GetExtendedMode: BOOL; virtual; stdcall; abstract;
    function PrepareMasks(var errorPos: Integer): BOOL; virtual; stdcall; abstract;
    function AgreeMasks(fileName: PAnsiChar; fileExt: PAnsiChar): BOOL; virtual; stdcall; abstract;
  end;

  TSalamanderMD5 = class
    procedure Init; virtual; stdcall; abstract;
    procedure Update(input: Pointer; input_length: DWORD); virtual; stdcall; abstract;
    procedure Finalize; virtual; stdcall; abstract;
    procedure GetDigest(dest: Pointer); virtual; stdcall; abstract;
  end;

  TSalamanderPNGAbstract = class
    function LoadPNGBitmap(hInstance: HINST; lpBitmapName: LPCTSTR; flags: DWORD; unused: COLORREF): HBITMAP; virtual; stdcall; abstract;
    function LoadRawPNGBitmap(rawPNG: Pointer; rawPNGSize: DWORD; flags: DWORD; unused: COLORREF): HBITMAP; virtual; stdcall; abstract;
  end;

  TSalamanderPasswordManagerAbstract = class
    function IsUsingMasterPassword: BOOL; virtual; stdcall; abstract;
    function IsMasterPasswordSet: BOOL; virtual; stdcall; abstract;
    function AskForMasterPassword(hParent: HWND): BOOL; virtual; stdcall; abstract;
    function EncryptPassword(plainPassword: PAnsiChar; var encryptedPassword: PBYTE; encryptedPasswordSize: PInteger; encrypt: BOOL): BOOL; virtual; stdcall; abstract;
    function DecryptPassword(encryptedPassword: PBYTE; encryptedPasswordSize: Integer; var plainPassword: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function IsPasswordEncrypted(encyptedPassword: PBYTE; encyptedPasswordSize: Integer): BOOL; virtual; stdcall; abstract;
  end;

  THtmlHelpCommand = (HHCDisplayTOC, HHCDisplayIndex, HHCDisplaySearch, HHCDisplayContext);

  TSalamanderGeneralAbstract = class
    function ShowMessageBox(text: PAnsiChar; title: PAnsiChar; _type: Integer): Integer; virtual; stdcall; abstract;
    function SalMessageBox(hParent: HWND; lpText: PAnsiChar; lpCaption: PAnsiChar; uType: UINT): Integer; virtual; stdcall; abstract;
    function SalMessageBoxEx(params: PMsgBoxExParams): Integer; virtual; stdcall; abstract;
    function GetMsgBoxParent: HWND; virtual; stdcall; abstract;
    function GetMainWindowHWND: HWND; virtual; stdcall; abstract;
    procedure RestoreFocusInSourcePanel; virtual; stdcall; abstract;
    function DialogError(parent: HWND; flags: DWORD; fileName: PAnsiChar; error: PAnsiChar; title: PAnsiChar): Integer; virtual; stdcall; abstract;
    function DialogOverwrite(parent: HWND; flags: DWORD; fileName1: PAnsiChar; fileData1: PAnsiChar; fileName2: PAnsiChar; fileData2: PAnsiChar): Integer; virtual; stdcall; abstract;
    function DialogQuestion(parent: HWND; flags: DWORD; fileName: PAnsiChar; question: PAnsiChar; title: PAnsiChar): Integer; virtual; stdcall; abstract;
    function CheckAndCreateDirectory(dir: PAnsiChar; parent: HWND = 0; quiet: BOOL = True; errBuf: PAnsiChar = nil; errBufSize: Integer = 0; firstCreatedDir: PAnsiChar = nil): BOOL; virtual; stdcall; abstract;
    function TestFreeSpace(parent: HWND; path: PAnsiChar; var totalSize: TQuadWord; messageTitle: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure GetDiskFreeSpace(retValue: PLargeInteger; path: PAnsiChar; total: PLargeInteger); virtual; stdcall; abstract;
    function SalGetDiskFreeSpace(path: PAnsiChar; lpSectorsPerCluster: LPDWORD; lpBytesPerSector: LPDWORD; lpNumberOfFreeClusters: LPDWORD; lpTotalNumberOfClusters: LPDWORD): BOOL; virtual; stdcall; abstract;
    function SalGetVolumeInformation(path: PAnsiChar; rootOrJunctionPoint: PAnsiChar; lpVolumeNameBuffer: PAnsiChar; nVolumeNameSize: DWORD; lpVolumeSerialNumber: LPDWORD; lpMaximumComponentLength: LPDWORD; lpFileSystemFlags: LPDWORD; lpFileSystemNameBuffer: PAnsiChar; nFileSystemNameSize: DWORD): BOOL; virtual; stdcall; abstract;
    function SalGetDriveType(path: PAnsiChar): UINT; virtual; stdcall; abstract;
    function SalGetTempFileName(path: PAnsiChar; prefix: PAnsiChar; tmpName: PAnsiChar; _file: BOOL; err: PDWORD): BOOL; virtual; stdcall; abstract;
    procedure RemoveTemporaryDir(dir: PAnsiChar); virtual; stdcall; abstract;
    function SalMoveFile(srcName: PAnsiChar; destName: PAnsiChar; err: PDWORD): BOOL; virtual; stdcall; abstract;
    function SalGetFileSize(_file: THandle; fullName: PAnsiChar; var size: TQuadWord; var err: DWORD): BOOL; virtual; stdcall; abstract;
    procedure ExecuteAssociation(parent: HWND; path: PAnsiChar; name: PAnsiChar); virtual; stdcall; abstract;
    function GetTargetDirectory(parent: HWND; hCenterWindow: HWND; title: PAnsiChar; comment: PAnsiChar; path: PAnsiChar; onlyNet: BOOL; initDir: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure PrepareMask(mask: PAnsiChar; src: PAnsiChar); virtual; stdcall; abstract;
    function AgreeMask(filename: PAnsiChar; mask: PAnsiChar; hasExtension: BOOL): BOOL; virtual; stdcall; abstract;
    function MaskName(buffer: PAnsiChar; bufSize: Integer; name: PAnsiChar; mask: PAnsiChar): PAnsiChar; virtual; stdcall; abstract;
    procedure PrepareExtMask(mask: PAnsiChar; src: PAnsiChar); virtual; stdcall; abstract;
    function AgreeExtMask(filename: PAnsiChar; mask: PAnsiChar; hasExtension: BOOL): BOOL; virtual; stdcall; abstract;
    function AllocSalamanderMaskGroup: TSalamanderMaskGroup; virtual; stdcall; abstract;
    procedure FreeSalamanderMaskGroup(maskGroup: TSalamanderMaskGroup); virtual; stdcall; abstract;
    function Alloc(size: Integer): Pointer; virtual; stdcall; abstract;
    procedure Free(ptr: Pointer); virtual; stdcall; abstract;
    function DupStr(str: PAnsiChar): PAnsiChar; virtual; stdcall; abstract;
    function DupStrEx(str: PAnsiChar; var err: BOOL): PAnsiChar; virtual; stdcall; abstract;
    procedure GetLowerAndUpperCase(lowerCase: PAnsiChar; upperCase: PAnsiChar); virtual; stdcall; abstract;
    procedure ToLowerCase(str: PAnsiChar); virtual; stdcall; abstract;
    procedure ToUpperCase(str: PAnsiChar); virtual; stdcall; abstract;
    function StrCmpEx(s1: PAnsiChar; l1: Integer; s2: PAnsiChar; l2: Integer): Integer; virtual; stdcall; abstract;
    function StrICpy(dest: PAnsiChar; src: PAnsiChar): Integer; virtual; stdcall; abstract;
    function StrICmp(s1: PAnsiChar; s2: PAnsiChar): Integer; virtual; stdcall; abstract;
    function StrICmpEx(s1: PAnsiChar; l1: Integer; s2: PAnsiChar; l2: Integer): Integer; virtual; stdcall; abstract;
    function StrNICmp(s1: PAnsiChar; s2: PAnsiChar; n: Integer): Integer; virtual; stdcall; abstract;
    function MemICmp(buf1: Pointer; buf2: Pointer; n: Integer): Integer; virtual; stdcall; abstract;
    function RegSetStrICmp(s1: PAnsiChar; s2: PAnsiChar): Integer; virtual; stdcall; abstract;
    function RegSetStrICmpEx(s1: PAnsiChar; l1: Integer; s2: PAnsiChar; l2: Integer; numericalyEqual: PBOOL): Integer; virtual; stdcall; abstract;
    function RegSetStrCmp(s1: PAnsiChar; s2: PAnsiChar): Integer; virtual; stdcall; abstract;
    function RegSetStrCmpEx(s1: PAnsiChar; l1: Integer; s2: PAnsiChar; l2: Integer; numericalyEqual: PBOOL): Integer; virtual; stdcall; abstract;
    function GetPanelPath(panel: Integer; buffer: PAnsiChar; bufferSize: Integer; _type: PInteger; archiveOrFS: PAnsiChar; convertFSPathToExternal: BOOL = False): BOOL; virtual; stdcall; abstract;
    function GetLastWindowsPanelPath(panel: Integer; buffer: PAnsiChar; bufferSize: Integer): BOOL; virtual; stdcall; abstract;
    procedure GetPluginFSName(buf: PAnsiChar; fsNameIndex: Integer); virtual; stdcall; abstract;
    function GetPanelPluginFS(panel: Integer): TPluginFSInterfaceAbstract; virtual; stdcall; abstract;
    function GetPanelPluginData(panel: Integer): TPluginDataInterfaceAbstract; virtual; stdcall; abstract;
    function GetPanelFocusedItem(panel: Integer; isDir: PBOOL): PFileData; virtual; stdcall; abstract;
    function GetPanelItem(panel: Integer; index: PInteger; isDir: PBOOL): PFileData; virtual; stdcall; abstract;
    function GetPanelSelectedItem(panel: Integer; index: PInteger; isDir: PBOOL): PFileData; virtual; stdcall; abstract;
    function GetPanelSelection(panel: Integer; selectedFiles: PInteger; selectedDirs: PInteger): BOOL; virtual; stdcall; abstract;
    function GetPanelTopIndex(panel: Integer): Integer; virtual; stdcall; abstract;
    procedure SkipOneActivateRefresh; virtual; stdcall; abstract;
    procedure SelectPanelItem(panel: Integer; _file: PFileData; select: BOOL); virtual; stdcall; abstract;
    procedure RepaintChangedItems(panel: Integer); virtual; stdcall; abstract;
    procedure SelectAllPanelItems(panel: Integer; select: BOOL; repaint: BOOL); virtual; stdcall; abstract;
    procedure SetPanelFocusedItem(panel: Integer; _file: PFileData; partVis: BOOL); virtual; stdcall; abstract;
    function GetFilterFromPanel(panel: Integer; masks: PAnsiChar; masksBufSize: Integer): BOOL; virtual; stdcall; abstract;
    function GetSourcePanel: Integer; virtual; stdcall; abstract;
    function GetPanelWithPluginFS(pluginFS: TPluginFSInterfaceAbstract; var panel: Integer): BOOL; virtual; stdcall; abstract;
    procedure ChangePanel; virtual; stdcall; abstract;
    function NumberToStr(buffer: PAnsiChar; var number: TQuadWord): PAnsiChar; virtual; stdcall; abstract;
    function PrintDiskSize(buf: PAnsiChar; var size: TQuadWord; mode: Integer): PAnsiChar; virtual; stdcall; abstract;
    function PrintTimeLeft(buf: PAnsiChar; var secs: TQuadWord): PAnsiChar; virtual; stdcall; abstract;
    function HasTheSameRootPath(path1: PAnsiChar; path2: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function CommonPrefixLength(path1: PAnsiChar; path2: PAnsiChar): Integer; virtual; stdcall; abstract;
    function PathIsPrefix(prefix: PAnsiChar; path: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function IsTheSamePath(path1: PAnsiChar; path2: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function GetRootPath(root: PAnsiChar; path: PAnsiChar): Integer; virtual; stdcall; abstract;
    function CutDirectory(path: PAnsiChar; cutDir: PAnsiChar = nil): BOOL; virtual; stdcall; abstract;
    function SalPathAppend(path: PAnsiChar; name: PAnsiChar; pathSize: Integer): BOOL; virtual; stdcall; abstract;
    function SalPathAddBackslash(path: PAnsiChar; pathSize: Integer): BOOL; virtual; stdcall; abstract;
    procedure SalPathRemoveBackslash(path: PAnsiChar); virtual; stdcall; abstract;
    procedure SalPathStripPath(path: PAnsiChar); virtual; stdcall; abstract;
    procedure SalPathRemoveExtension(path: PAnsiChar); virtual; stdcall; abstract;
    function SalPathAddExtension(path: PAnsiChar; extension: PAnsiChar; pathSize: Integer): BOOL; virtual; stdcall; abstract;
    function SalPathRenameExtension(path: PAnsiChar; extension: PAnsiChar; pathSize: Integer): BOOL; virtual; stdcall; abstract;
    function SalPathFindFileName(path: PAnsiChar): PAnsiChar; virtual; stdcall; abstract;
    function SalGetFullName(name: PAnsiChar; errTextID: PInteger = nil; curDir: PAnsiChar = nil; nextFocus: PAnsiChar = nil): BOOL; virtual; stdcall; abstract;
    procedure SalUpdateDefaultDir(activePrefered: BOOL); virtual; stdcall; abstract;
    function GetGFNErrorText(GFN: Integer; buf: PAnsiChar; bufSize: Integer): PAnsiChar; virtual; stdcall; abstract;
    function GetErrorText(err: Integer; buf: PAnsiChar = nil; bufSize: Integer = 0): PAnsiChar; virtual; stdcall; abstract;
    function GetCurrentColor(color: Integer): TColorRef; virtual; stdcall; abstract;
    procedure FocusNameInPanel(panel: Integer; path: PAnsiChar; name: PAnsiChar); virtual; stdcall; abstract;
    function ChangePanelPath(panel: Integer; path: PAnsiChar; failReason: PInteger = nil; suggestedTopIndex: Integer = -1; suggestedFocusName: PAnsiChar = nil; convertFSPathToInternal: BOOL = True): BOOL; virtual; stdcall; abstract;
    function ChangePanelPathToDisk(panel: Integer; path: PAnsiChar; failReason: PInteger = nil; suggestedTopIndex: Integer = -1; suggestedFocusName: PAnsiChar = nil): BOOL; virtual; stdcall; abstract;
    function ChangePanelPathToArchive(panel: Integer; archive: PAnsiChar; archivePath: PAnsiChar; failReason: PInteger = nil; suggestedTopIndex: Integer = -1;suggestedFocusName: PAnsiChar = nil; forceUpdate: BOOL = False): BOOL; virtual; stdcall; abstract;
    function ChangePanelPathToPluginFS(panel: Integer; fsName: PAnsiChar; fsUserPart: PAnsiChar; failReason: PInteger = nil; suggestedTopIndex: Integer = -1; suggestedFocusName: PAnsiChar = nil; forceUpdate: BOOL = False; convertPathToInternal: BOOL = False): BOOL; virtual; stdcall; abstract;
    function ChangePanelPathToDetachedFS(panel: Integer; detachedFS: TPluginFSInterfaceAbstract; failReason: PInteger = nil; suggestedTopIndex: Integer = -1; suggestedFocusName: PAnsiChar = nil): BOOL; virtual; stdcall; abstract;
    function ChangePanelPathToFixedDrive(panel: Integer; failReason: PInteger = nil): BOOL; virtual; stdcall; abstract;
    procedure RefreshPanelPath(panel: Integer; forceRefresh: BOOL = False; focusFirstNewItem: BOOL = False); virtual; stdcall; abstract;
    function PostRefreshPanelPath(panel: Integer; focusFirstNewItem: BOOL = False): BOOL; virtual; stdcall; abstract;
    procedure PostRefreshPanelFS(modifiedFS: TPluginFSInterfaceAbstract; focusFirstNewItem: BOOL = False); virtual; stdcall; abstract;
    function CloseDetachedFS(parent: HWND; detachedFS: TPluginFSInterfaceAbstract): BOOL; virtual; stdcall; abstract;
    function DuplicateAmpersands(buffer: PAnsiChar; bufferSize: Integer): BOOL; virtual; stdcall; abstract;
    procedure RemoveAmpersands(text: PAnsiChar); virtual; stdcall; abstract;
    function ValidateVarString(msgParent: HWND; varText: PAnsiChar; var errorPos1: Integer; var errorPos2: Integer; variables: PSalamanderVarStrEntry): BOOL; virtual; stdcall; abstract;
    function ExpandVarString(msgParent: HWND; varText: PAnsiChar; buffer: PAnsiChar; bufferLen: Integer; variables: PSalamanderVarStrEntry; param: Pointer; ignoreEnvVarNotFoundOrTooLong: BOOL = False; varPlacements: PDWORD = nil; varPlacementsCount: PInteger = nil; detectMaxVarWidths: BOOL = False; maxVarWidths: PInteger = nil; maxVarWidthsCount: Integer = 0): BOOL; virtual; stdcall; abstract;
    function SetFlagLoadOnSalamanderStart(start: BOOL): BOOL; virtual; stdcall; abstract;
    procedure PostUnloadThisPlugin; virtual; stdcall; abstract;
    function EnumInstalledModules(index: PInteger; module: PAnsiChar; version: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure CallLoadOrSaveConfiguration(load: BOOL; loadOrSaveFunc: TSalLoadOrSaveConfigurationProc; param: Pointer); virtual; stdcall; abstract;
    function CopyTextToClipboard(text: PAnsiChar; textLen: Integer; showEcho: BOOL; echoParent: HWND): BOOL; virtual; stdcall; abstract;
    function CopyTextToClipboardW(text: PWChar; textLen: Integer; showEcho: BOOL; echoParent: HWND): BOOL; virtual; stdcall; abstract;
    procedure PostMenuExtCommand(id: Integer; waitForSalIdle: BOOL); virtual; stdcall; abstract;
    function SalamanderIsNotBusy(lastIdleTime: PDWORD): BOOL; virtual; stdcall; abstract;
    procedure SetPluginBugReportInfo(message: PAnsiChar; email: PAnsiChar); virtual; stdcall; abstract;
    function IsPluginInstalled(pluginSPL: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function ViewFileInPluginViewer(pluginSPL: PAnsiChar; pluginData: PSalamanderPluginViewerData; useCache: BOOL; rootTmpPath: PAnsiChar; fileNameInCache: PAnsiChar; var error: Integer): BOOL; virtual; stdcall; abstract;
    procedure PostChangeOnPathNotification(path: PAnsiChar; includingSubdirs: BOOL); virtual; stdcall; abstract;
    function SalCheckPath(echo: BOOL; path: PAnsiChar; err: DWORD; parent: HWND): DWORD; virtual; stdcall; abstract;
    function SalCheckAndRestorePath(parent: HWND; path: PAnsiChar; tryNet: BOOL): BOOL; virtual; stdcall; abstract;
    function SalCheckAndRestorePathWithCut(parent: HWND; path: PAnsiChar; var tryNet: BOOL; var err: DWORD; var lastErr: DWORD; var pathInvalid: BOOL; var cut: BOOL; donotReconnect: BOOL): BOOL; virtual; stdcall; abstract;
    function SalParsePath(parent: HWND; path: PAnsiChar; var _type: Integer; var isDir: BOOL; var secondPart: PAnsiChar; errorTitle: PAnsiChar; nextFocus: PAnsiChar; curPathIsDiskOrArchive: BOOL; curPath: PAnsiChar; curArchivePath: PAnsiChar; error: PInteger): BOOL; virtual; stdcall; abstract;
    function SalSplitWindowsPath(parent: HWND; title: PAnsiChar; errorTitle: PAnsiChar; selCount: Integer; path: PAnsiChar; secondPart: PAnsiChar; pathIsDir: BOOL; backslashAtEnd: BOOL; dirName: PAnsiChar; curDiskPath: PAnsiChar; var mask: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function SalSplitGeneralPath(parent: HWND; title: PAnsiChar; errorTitle: PAnsiChar; selCount: Integer; path: PAnsiChar; afterRoot: PAnsiChar; secondPart: PAnsiChar; pathIsDir: BOOL; backslashAtEnd: BOOL; dirName: PAnsiChar; curPath: PAnsiChar; var mask: PAnsiChar; newDirs: PAnsiChar; isTheSamePathF: TSGP_IsTheSamePathFunc): BOOL; virtual; stdcall; abstract;
    function SalRemovePointsFromPath(afterRoot: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function GetConfigParameter(paramID: Integer; buffer: Pointer; bufferSize: Integer; _type: PInteger): BOOL; virtual; stdcall; abstract;
    procedure AlterFileName(tgtName: PAnsiChar; srcName: PAnsiChar; format: Integer; changedParts: Integer; isDir: BOOL); virtual; stdcall; abstract;
    procedure CreateSafeWaitWindow(message: PAnsiChar; caption: PAnsiChar; delay: Integer; showCloseButton: BOOL; hForegroundWnd: HWND); virtual; stdcall; abstract;
    procedure DestroySafeWaitWindow; virtual; stdcall; abstract;
    procedure ShowSafeWaitWindow(show: BOOL); virtual; stdcall; abstract;
    function GetSafeWaitWindowClosePressed: BOOL; virtual; stdcall; abstract;
    procedure SetSafeWaitWindowText(message: PAnsiChar); virtual; stdcall; abstract;
    function GetFileFromCache(uniqueFileName: PAnsiChar; var tmpName: PAnsiChar; fileLock: THandle): BOOL; virtual; stdcall; abstract;
    procedure UnlockFileInCache(fileLock: THandle); virtual; stdcall; abstract;
    function MoveFileToCache(uniqueFileName: PAnsiChar; nameInCache: PAnsiChar; rootTmpPath: PAnsiChar; newFileName: PAnsiChar; var newFileSize: TQuadWord; alreadyExists: PBOOL): BOOL; virtual; stdcall; abstract;
    procedure RemoveOneFileFromCache(uniqueFileName: PAnsiChar); virtual; stdcall; abstract;
    procedure RemoveFilesFromCache(fileNamesRoot: PAnsiChar); virtual; stdcall; abstract;
    function EnumConversionTables(parent: HWND; index: PInteger; name: PAnsiChar; table: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function GetConversionTable(parent: HWND; table: PAnsiChar; conversion: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure GetWindowsCodePage(parent: HWND; codePage: PAnsiChar); virtual; stdcall; abstract;
    procedure RecognizeFileType(parent: HWND; pattern: PAnsiChar; patternLen: Integer; forceText: BOOL; isText: PBOOL; codePage: PAnsiChar); virtual; stdcall; abstract;
    function IsANSIText(text: PAnsiChar; textLen: Integer): BOOL; virtual; stdcall; abstract;
    procedure CallPluginOperationFromDisk(panel: Integer; callback: TSalPluginOperationFromDiskProc; param: Pointer); virtual; stdcall; abstract;
    function GetUserDefaultCharset: Byte; virtual; stdcall; abstract;
    function AllocSalamanderBMSearchData: TSalamanderBMSearchData; virtual; stdcall; abstract;
    procedure FreeSalamanderBMSearchData(data: TSalamanderBMSearchData); virtual; stdcall; abstract;
    function AllocSalamanderREGEXPSearchData: TSalamanderREGEXPSearchData; virtual; stdcall; abstract;
    procedure FreeSalamanderREGEXPSearchData(data: TSalamanderREGEXPSearchData); virtual; stdcall; abstract;
    function EnumSalamanderCommands(index: PInteger; salCmd: PInteger; nameBuf: PAnsiChar; nameBufSize: Integer; enabled: PBOOL; _type: PInteger): BOOL; virtual; stdcall; abstract;
    function GetSalamanderCommand(salCmd: Integer; nameBuf: PAnsiChar; nameBufSize: Integer; enabled: PBOOL; _type: PInteger): BOOL; virtual; stdcall; abstract;
    procedure PostSalamanderCommand(salCmd: Integer); virtual; stdcall; abstract;
    procedure SetUserWorkedOnPanelPath(panel: Integer); virtual; stdcall; abstract;
    procedure StoreSelectionOnPanelPath(panel: Integer); virtual; stdcall; abstract;
    function UpdateCrc32(buffer: Pointer; count: DWORD; crcVal: DWORD): DWORD; virtual; stdcall; abstract;
    function AllocSalamanderMD5: TSalamanderMD5; virtual; stdcall; abstract;
    procedure FreeSalamanderMD5(md5: TSalamanderMD5); virtual; stdcall; abstract;
    function LookForSubTexts(text: PAnsiChar; varPlacements: PDWORD; varPlacementsCount: PInteger): BOOL; virtual; stdcall; abstract;
    procedure WaitForESCRelease; virtual; stdcall; abstract;
    function GetMouseWheelMsg: DWORD; virtual; stdcall; abstract;
    function GetMouseWheelScrollLines: DWORD; virtual; stdcall; abstract;
    function GetTopVisibleParent(hParent: HWND): HWND; virtual; stdcall; abstract;
    function MultiMonGetDefaultWindowPos(hByWnd: HWND; p: PPoint): BOOL; virtual; stdcall; abstract;
    procedure MultiMonGetClipRectByRect(rect: PRect; workClipRect: PRect; monitorClipRect: PRect); virtual; stdcall; abstract;
    procedure MultiMonGetClipRectByWindow(hByWnd: HWND; workClipRect: PRect; monitorClipRect: PRect); virtual; stdcall; abstract;
    procedure MultiMonCenterWindow(hWindow: HWND; hByWnd: HWND; findTopWindow: BOOL); virtual; stdcall; abstract;
    function MultiMonEnsureRectVisible(rect: PRect; partialOK: BOOL): BOOL; virtual; stdcall; abstract;
    function InstallWordBreakProc(hWindow: HWND): BOOL; virtual; stdcall; abstract;
    function IsFirstInstance252beta1OrLater: BOOL; virtual; stdcall; abstract;
    function ExpandPluralString(buffer: PAnsiChar; bufferSize: Integer; format: PAnsiChar; parametersCount: Integer; parametersArray: PLargeInteger): Integer; virtual; stdcall; abstract;
    function ExpandPluralFilesDirs(buffer: PAnsiChar; bufferSize: Integer; files: Integer; dirs: Integer; mode: Integer; forDlgCaption: BOOL): Integer; virtual; stdcall; abstract;
    function ExpandPluralBytesFilesDirs(buffer: PAnsiChar; bufferSize: Integer; var selectedBytes: TQuadWord; files: Integer; dirs: Integer; useSubTexts: BOOL): Integer; virtual; stdcall; abstract;
    procedure GetCommonFSOperSourceDescr(sourceDescr: PAnsiChar; sourceDescrSize: Integer; panel: Integer; selectedFiles: Integer; selectedDirs: Integer; fileOrDirName: PAnsiChar; isDir: BOOL; forDlgCaption: BOOL); virtual; stdcall; abstract;
    procedure AddStrToStr(dstStr: PAnsiChar; dstBufSize: Integer; srcStr: PAnsiChar); virtual; stdcall; abstract;
    function SalIsValidFileNameComponent(fileNameComponent: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure SalMakeValidFileNameComponent(fileNameComponent: PAnsiChar); virtual; stdcall; abstract;
    function IsFileEnumSourcePanel(srcUID: Integer; panel: PInteger): BOOL; virtual; stdcall; abstract;
    function GetNextFileNameForViewer(srcUID: Integer; lastFileIndex: PInteger; lastFileName: PAnsiChar; preferSelected: BOOL; onlyAssociatedExtensions: BOOL; fileName: PAnsiChar; noMoreFiles: PBOOL; srcBusy: PBOOL): BOOL; virtual; stdcall; abstract;
    function GetPreviousFileNameForViewer(srcUID: Integer; lastFileIndex: PInteger; lastFileName: PAnsiChar; preferSelected: BOOL; onlyAssociatedExtensions: BOOL; fileName: PAnsiChar; noMoreFiles: PBOOL; srcBusy: PBOOL): BOOL; virtual; stdcall; abstract;
    function IsFileNameForViewerSelected(srcUID: Integer; lastFileIndex: Integer; lastFileName: PAnsiChar; isFileSelected: PBOOL; srcBusy: PBOOL): BOOL; virtual; stdcall; abstract;
    function SetSelectionOnFileNameForViewer(srcUID: Integer; lastFileIndex: Integer; lastFileName: PAnsiChar; select: BOOL; srcBusy: PBOOL): BOOL; virtual; stdcall; abstract;
    function GetStdHistoryValues(historyID: Integer; historyArr: PAnsiChar; historyItemsCount: PInteger): BOOL; virtual; stdcall; abstract;
    procedure AddValueToStdHistoryValues(historyArr: PAnsiChar; historyItemsCount: Integer; value: PAnsiChar; caseSensitiveValue: BOOL); virtual; stdcall; abstract;
    procedure LoadComboFromStdHistoryValues(combo: HWND; historyArr: PAnsiChar; historyItemsCount: Integer); virtual; stdcall; abstract;
    function CanUse256ColorsBitmap: BOOL; virtual; stdcall; abstract;
    function GetWndToFlash(parent: HWND): HWND; virtual; stdcall; abstract;
    procedure ActivateDropTarget(dropTarget: HWND; progressWnd: HWND); virtual; stdcall; abstract;
    procedure PostOpenPackDlgForThisPlugin(delFilesAfterPacking: Integer); virtual; stdcall; abstract;
    procedure PostOpenUnpackDlgForThisPlugin(unpackMask: PAnsiChar); virtual; stdcall; abstract;
    function SalCreateFileEx(fileName: PAnsiChar; desiredAccess: DWORD; shareMode: DWORD; flagsAndAttributes: DWORD; err: PDWORD): THandle; virtual; stdcall; abstract;
    function SalCreateDirectoryEx(name: PAnsiChar; err: PDWORD): BOOL; virtual; stdcall; abstract;
    procedure PanelStopMonitoring(panel: Integer; stopMonitoring: BOOL); virtual; stdcall; abstract;
    function AllocSalamanderDirectory(isForFS: BOOL): TSalamanderDirectoryAbstract; virtual; stdcall; abstract;
    procedure FreeSalamanderDirectory(salDir: TSalamanderDirectoryAbstract); virtual; stdcall; abstract;
    function RSAKeyValid(keyContent: PAnsiChar; keyContentSize: PDWORD): BOOL; virtual; stdcall; abstract;
    function AddPluginFSTimer(timeout: Integer; timerOwner: TPluginFSInterfaceAbstract; timerParam: DWORD): BOOL; virtual; stdcall; abstract;
    function KillPluginFSTimer(timerOwner: TPluginFSInterfaceAbstract; allTimers: BOOL; timerParam: DWORD): Integer; virtual; stdcall; abstract;
    function GetChangeDriveMenuItemVisibility: BOOL; virtual; stdcall; abstract;
    procedure SetChangeDriveMenuItemVisibility(visible: BOOL); virtual; stdcall; abstract;
    procedure OleSpySetBreak(alloc: Integer); virtual; stdcall; abstract;
    function GetSalamanderIcon(icon: Integer; iconSize: Integer): HICON; virtual; stdcall; abstract;
    function GetFileIcon(path: PAnsiChar; pathIsPIDL: BOOL; hIcon: PHICON; iconSize: Integer): BOOL; virtual; stdcall; abstract;
    function FileExists(fileName: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure DisconnectFSFromPanel(parent: HWND; panel: Integer); virtual; stdcall; abstract;
    function IsArchiveHandledByThisPlugin(name: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function GetIconLRFlags: DWORD; virtual; stdcall; abstract;
    function IsFileLink(fileExtension: PAnsiChar): Integer; virtual; stdcall; abstract;
    function GetImageListColorFlags: DWORD; virtual; stdcall; abstract;
    function SafeGetOpenFileName(lpofn: POpenFilename): BOOL; virtual; stdcall; abstract;
    function SafeGetSaveFileName(lpofn: POpenFilename): BOOL; virtual; stdcall; abstract;
    procedure SetHelpFileName(chmName: PAnsiChar); virtual; stdcall; abstract;
    function OpenHtmlHelp(parent: HWND; command: THtmlHelpCommand; dwData: UINT; quiet: BOOL): BOOL; virtual; stdcall; abstract;
    function ReadRegistrationKey(dllInstance: HINST; keyName: PAnsiChar; keyNotFound: PBOOL; keyContent: PAnsiChar; keyContentSize: PDWORD; fullKeyName: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function PathsAreOnTheSameVolume(path1: PAnsiChar; path2: PAnsiChar; resIsOnlyEstimation: PBOOL): BOOL; virtual; stdcall; abstract;
    procedure Realloc(ptr: Pointer; size: Integer); virtual; stdcall; abstract;
    procedure GetPanelEnumFilesParams(panel: Integer; enumFilesSourceUID: PInteger; enumFilesCurrentIndex: PInteger); virtual; stdcall; abstract;
    function PostRefreshPanelFS2(modifiedFS: TPluginFSInterfaceAbstract; focusFirstNewItem: BOOL = False): BOOL; virtual; stdcall; abstract;
    function LoadStr(module: HINST; resID: Integer): PAnsiChar; virtual; stdcall; abstract;
    function ChangePanelPathToRescuePathOrFixedDrive(panel: Integer; failReason: PInteger = nil): BOOL; virtual; stdcall; abstract;
    procedure SetPluginIsNethood; virtual; stdcall; abstract;
    procedure OpenNetworkContextMenu(parent: HWND; panel: Integer; forItems: BOOL; menuX: Integer; menuY: Integer; netPath: PAnsiChar; newlyMappedDrive: PAnsiChar); virtual; stdcall; abstract;
    function DuplicateBackslashes(buffer: PAnsiChar; bufferSize: Integer): BOOL; virtual; stdcall; abstract;
    function StartThrobber(panel: Integer; tooltip: PAnsiChar; delay: Integer): Integer; virtual; stdcall; abstract;
    function StopThrobber(id: Integer): BOOL; virtual; stdcall; abstract;
    procedure ShowSecurityIcon(panel: Integer; showIcon: BOOL; isLocked: BOOL; tooltip: PAnsiChar); virtual; stdcall; abstract;
    procedure RemoveCurrentPathFromHistory(panel: Integer); virtual; stdcall; abstract;
    procedure OpenPurchasePage(parent: HWND); virtual; stdcall; abstract;
    function IsUserAdmin: BOOL; virtual; stdcall; abstract;
    function IsRemoteSession: BOOL; virtual; stdcall; abstract;
    function SalWNetAddConnection2Interactive(lpNetResource: Pointer): DWORD; virtual; stdcall; abstract;
    function GetWindowsVersion(query: DWORD): BOOL; virtual; stdcall; abstract;
    function GetMouseWheelScrollChars: DWORD; virtual; stdcall; abstract;
    function GetSalamanderZLIB: TSalamanderZLIBAbstract; virtual; stdcall; abstract;
    function GetFileIcon2(path: PAnsiChar; pathIsPIDL: BOOL; _hIcon: HICON; iconSize: Integer; fallbackToDefIcon: BOOL; defIconIsDir: BOOL): BOOL; virtual; stdcall; abstract;
    function GetSalamanderPNG: TSalamanderPNGAbstract; virtual; stdcall; abstract;
    function GetSalamanderCrypt: TSalamanderCryptAbstract; virtual; stdcall; abstract;
    procedure SetPluginUsesPasswordManager; virtual; stdcall; abstract;
    function GetSalamanderPasswordManager: TSalamanderPasswordManagerAbstract; virtual; stdcall; abstract;
    function OpenHtmlHelpForSalamander(parent: HWND; command: THtmlHelpCommand; dwData: UINT; quiet: BOOL): BOOL; virtual; stdcall; abstract;
    function GetSalamanderBZIP2: TSalamanderBZIP2Abstract; virtual; stdcall; abstract;
    procedure GetFocusedItemMenuPos(pos: PPoint); virtual; stdcall; abstract;
    procedure LockMainWindow(lock: BOOL; hToolWnd: HWND; lockReason: PAnsiChar); virtual; stdcall; abstract;
    procedure PostPluginMenuChanged; virtual; stdcall; abstract;
    function GetMenuItemHotKey(id: Integer; hotKey: PWORD; hotKeyText: PAnsiChar; hotKeyTextSize: Integer): BOOL; virtual; stdcall; abstract;
    function PathsAreOnTheSameVolume_P(path1: PAnsiChar; path2: PAnsiChar; resIsOnlyEstimation: PBOOL): BOOL; virtual; stdcall;
    procedure Realloc_P(ptr: Pointer; size: Integer); virtual; stdcall;
    procedure GetPanelEnumFilesParams_P(panel: Integer; enumFilesSourceUID: PInteger; enumFilesCurrentIndex: PInteger); virtual; stdcall;
    function PostRefreshPanelFS2_P(modifiedFS: TPluginFSInterfaceAbstract; focusFirstNewItem: BOOL = False): BOOL; virtual; stdcall;
    function LoadStr_P(module: HINST; resID: Integer): PAnsiChar; virtual; stdcall;
    procedure SetPluginIsNethood_P; virtual; stdcall;
    procedure OpenNetworkContextMenu_P(parent: HWND; panel: Integer; forItems: BOOL; menuX: Integer; menuY: Integer; netPath: PAnsiChar; newlyMappedDrive: PAnsiChar); virtual; stdcall;
    function DuplicateBackslashes_P(buffer: PAnsiChar; bufferSize: Integer): BOOL; virtual; stdcall;
    function StartThrobber_P(panel: Integer; tooltip: PAnsiChar; delay: Integer): Integer; virtual; stdcall;
    function StopThrobber_P(id: Integer): BOOL; virtual; stdcall;
    procedure ShowSecurityIcon_P(panel: Integer; showIcon: BOOL; isLocked: BOOL; tooltip: PAnsiChar); virtual; stdcall;
    procedure RemoveCurrentPathFromHistory_P(panel: Integer); virtual; stdcall;
    procedure OpenPurchasePage_P(parent: HWND); virtual; stdcall;
    function IsUserAdmin_P: BOOL; virtual; stdcall;
    function IsRemoteSession_P: BOOL; virtual; stdcall;
    function SalWNetAddConnection2Interactive_P(lpNetResource: Pointer): DWORD; virtual; stdcall;
    function GetWindowsVersion_P(query: DWORD): BOOL; virtual; stdcall;
    function GetMouseWheelScrollChars_P: DWORD; virtual; stdcall;
    function GetSalamanderZLIB_P: TSalamanderZLIBAbstract; virtual; stdcall;
    function GetFileIcon2_P(path: PAnsiChar; pathIsPIDL: BOOL; _hIcon: HICON; iconSize: Integer; fallbackToDefIcon: BOOL; defIconIsDir: BOOL): BOOL; virtual; stdcall;
    function GetSalamanderPNG_P: TSalamanderPNGAbstract; virtual; stdcall;
    function GetSalamanderCrypt_P: TSalamanderCryptAbstract; virtual; stdcall;
    procedure SetPluginUsesPasswordManager_P; virtual; stdcall; 
    function GetSalamanderPasswordManager_P: TSalamanderPasswordManagerAbstract; virtual; stdcall;
    function OpenHtmlHelpForSalamander_P(parent: HWND; command: THtmlHelpCommand; dwData: UINT; quiet: BOOL): BOOL; virtual; stdcall;
    function GetSalamanderBZIP2_P: TSalamanderBZIP2Abstract; virtual; stdcall;
    procedure GetFocusedItemMenuPos_P(pos: PPoint); virtual; stdcall;
    procedure LockMainWindow_P(lock: BOOL; hToolWnd: HWND; lockReason: PAnsiChar); virtual; stdcall;
    procedure PostPluginMenuChanged_P; virtual; stdcall;
    function GetMenuItemHotKey_P(id: Integer; hotKey: PWORD; hotKeyText: PAnsiChar; hotKeyTextSize: Integer): BOOL; virtual; stdcall;
  end;

function ButtonsContainsSkip(btn: DWORD): BOOL;
function ButtonsContainsYes(btn: DWORD): BOOL;

implementation

function TSalamanderGeneralAbstract.PathsAreOnTheSameVolume_P(path1: PAnsiChar; path2: PAnsiChar; resIsOnlyEstimation: PBOOL): BOOL;
begin
  Result := PathsAreOnTheSameVolume(path1, path2, resIsOnlyEstimation);
end;

procedure TSalamanderGeneralAbstract.Realloc_P(ptr: Pointer; size: Integer);
begin
  Realloc(ptr, size);
end;

procedure TSalamanderGeneralAbstract.GetPanelEnumFilesParams_P(panel: Integer; enumFilesSourceUID: PInteger; enumFilesCurrentIndex: PInteger);
begin
  GetPanelEnumFilesParams(panel, enumFilesSourceUID, enumFilesCurrentIndex);
end;

function TSalamanderGeneralAbstract.PostRefreshPanelFS2_P(modifiedFS: TPluginFSInterfaceAbstract; focusFirstNewItem: BOOL = False): BOOL;
begin
  Result := PostRefreshPanelFS2(modifiedFS, focusFirstNewItem);
end;

function TSalamanderGeneralAbstract.LoadStr_P(module: HINST; resID: Integer): PAnsiChar;
begin
  Result := LoadStr(module, resID);
end;

procedure TSalamanderGeneralAbstract.SetPluginIsNethood_P;
begin
  SetPluginIsNethood;
end;

procedure TSalamanderGeneralAbstract.OpenNetworkContextMenu_P(parent: HWND; panel: Integer; forItems: BOOL; menuX: Integer; menuY: Integer; netPath: PAnsiChar; newlyMappedDrive: PAnsiChar);
begin
  OpenNetworkContextMenu(parent, panel, forItems, menuX, menuY, netPath, newlyMappedDrive);
end;

function TSalamanderGeneralAbstract.DuplicateBackslashes_P(buffer: PAnsiChar; bufferSize: Integer): BOOL;
begin
  Result := DuplicateBackslashes(buffer, bufferSize);
end;

function TSalamanderGeneralAbstract.StartThrobber_P(panel: Integer; tooltip: PAnsiChar; delay: Integer): Integer;
begin
  Result := StartThrobber(panel, tooltip, delay);
end;

function TSalamanderGeneralAbstract.StopThrobber_P(id: Integer): BOOL;
begin
  Result := StopThrobber(id);
end;

procedure TSalamanderGeneralAbstract.ShowSecurityIcon_P(panel: Integer; showIcon: BOOL; isLocked: BOOL; tooltip: PAnsiChar);
begin
  ShowSecurityIcon(panel, showIcon, isLocked, tooltip);
end;

procedure TSalamanderGeneralAbstract.RemoveCurrentPathFromHistory_P(panel: Integer);
begin
  RemoveCurrentPathFromHistory(panel);
end;

procedure TSalamanderGeneralAbstract.OpenPurchasePage_P(parent: HWND);
begin
  OpenPurchasePage(parent);
end;

function TSalamanderGeneralAbstract.IsUserAdmin_P: BOOL;
begin
  Result := IsUserAdmin;
end;

function TSalamanderGeneralAbstract.IsRemoteSession_P: BOOL;
begin
  Result := IsRemoteSession;
end;

function TSalamanderGeneralAbstract.SalWNetAddConnection2Interactive_P(lpNetResource: Pointer): DWORD;
begin
  Result := SalWNetAddConnection2Interactive(lpNetResource);
end;

function TSalamanderGeneralAbstract.GetWindowsVersion_P(query: DWORD): BOOL;
begin
  Result := GetWindowsVersion(query);
end;

function TSalamanderGeneralAbstract.GetMouseWheelScrollChars_P: DWORD;
begin
  Result := GetMouseWheelScrollChars;
end;

function TSalamanderGeneralAbstract.GetSalamanderZLIB_P: TSalamanderZLIBAbstract;
begin
  Result := GetSalamanderZLIB;
end;

function TSalamanderGeneralAbstract.GetFileIcon2_P(path: PAnsiChar; pathIsPIDL: BOOL; _hIcon: HICON; iconSize: Integer; fallbackToDefIcon: BOOL; defIconIsDir: BOOL): BOOL;
begin
  Result := GetFileIcon2(path, pathIsPIDL, _hIcon, iconSize, fallbackToDefIcon, defIconIsDir);
end;

function TSalamanderGeneralAbstract.GetSalamanderPNG_P: TSalamanderPNGAbstract;
begin
  Result := GetSalamanderPNG;
end;

function TSalamanderGeneralAbstract.GetSalamanderCrypt_P: TSalamanderCryptAbstract;
begin
  Result := GetSalamanderCrypt;
end;

procedure TSalamanderGeneralAbstract.SetPluginUsesPasswordManager_P;
begin
  SetPluginUsesPasswordManager;
end;

function TSalamanderGeneralAbstract.GetSalamanderPasswordManager_P: TSalamanderPasswordManagerAbstract;
begin
  Result := GetSalamanderPasswordManager;
end;

function TSalamanderGeneralAbstract.OpenHtmlHelpForSalamander_P(parent: HWND; command: THtmlHelpCommand; dwData: UINT; quiet: BOOL): BOOL;
begin
  Result := OpenHtmlHelpForSalamander(parent, command, dwData, quiet);
end;

function TSalamanderGeneralAbstract.GetSalamanderBZIP2_P: TSalamanderBZIP2Abstract;
begin
  Result := GetSalamanderBZIP2;
end;

procedure TSalamanderGeneralAbstract.GetFocusedItemMenuPos_P(pos: PPoint);
begin
  GetFocusedItemMenuPos(pos);
end;

procedure TSalamanderGeneralAbstract.LockMainWindow_P(lock: BOOL; hToolWnd: HWND; lockReason: PAnsiChar);
begin
  LockMainWindow(lock, hToolWnd, lockReason);
end;

procedure TSalamanderGeneralAbstract.PostPluginMenuChanged_P;
begin
  PostPluginMenuChanged;
end;

function TSalamanderGeneralAbstract.GetMenuItemHotKey_P(id: Integer; hotKey: PWORD; hotKeyText: PAnsiChar; hotKeyTextSize: Integer): BOOL;
begin
  Result := GetMenuItemHotKey(id, hotKey, hotKeyText, hotKeyTextSize);
end;

function ButtonsContainsSkip(btn: DWORD): BOOL;
begin
  Result:= ((btn and BUTTONS_MASK) = BUTTONS_SKIPCANCEL) or ((btn and BUTTONS_MASK) = BUTTONS_RETRYSKIPCANCEL) or ((btn and BUTTONS_MASK) = BUTTONS_YESALLSKIPCANCEL);
end;

function ButtonsContainsYes(btn: DWORD): BOOL;
begin
  Result:= ((btn and BUTTONS_MASK) = BUTTONS_YESALLSKIPCANCEL) or ((btn and BUTTONS_MASK) = BUTTONS_YESNOCANCEL) or ((btn and BUTTONS_MASK) = BUTTONS_YESALLCANCEL);
end;

end.

