unit spl_menu;

interface

uses
  Windows,
  spl_com,
  spl_gui;

const
  MENU_ITEM_STATE_ENABLED = $01;
  MENU_ITEM_STATE_CHECKED = $02;
  MENU_ITEM_STATE_RADIO = $04;
  MENU_ITEM_STATE_HIDDEN = $08;

type
  TSalamanderBuildMenuAbstract = class
    procedure AddMenuItem(iconIndex: Integer; name: PAnsiChar; hotKey: DWORD; id: Integer; callGetState: BOOL; state_or: DWORD; state_and: DWORD; skillLevel: DWORD); virtual; stdcall; abstract;
    procedure AddSubmenuStart(iconIndex: Integer; name: PAnsiChar; id: Integer; callGetState: BOOL; state_or: DWORD; state_and: DWORD; skillLevel: DWORD); virtual; stdcall; abstract;
    procedure AddSubmenuEnd; virtual; stdcall; abstract;
    procedure SetIconListForMenu(iconList: TGUIIconListAbstract); virtual; stdcall; abstract;
  end;

  TPluginInterfaceForMenuExtAbstract = class
    function GetMenuItemState(id: Integer; eventMask: DWORD): DWORD; virtual; stdcall; abstract;
    function ExecuteMenuItem(salamander: TSalamanderForOperationsAbstract; parent: HWND; id: Integer; eventMask: DWORD): BOOL; virtual; stdcall; abstract;
    function HelpForMenuItem(parent: HWND; id: Integer): BOOL; virtual; stdcall; abstract;
    procedure BuildMenu(parent: HWND; salamander: TSalamanderBuildMenuAbstract); virtual; stdcall; abstract;
  end;

implementation

end.
