unit spl_thum;

interface

uses
  Windows;

const
  SSTHUMB_MIRROR_HOR = 1;
  SSTHUMB_MIRROR_VERT = 2;
  SSTHUMB_ROTATE_90CW = 4;
  SSTHUMB_ROTATE_180 = (SSTHUMB_MIRROR_VERT or SSTHUMB_MIRROR_HOR);
  SSTHUMB_ROTATE_90CCW = (SSTHUMB_ROTATE_90CW or SSTHUMB_ROTATE_180);
  SSTHUMB_ONLY_PREVIEW = 8;

type
  TSalamanderThumbnailMakerAbstract = class
    function SetParameters(picWidth: Integer; picHeight: Integer; flags: DWORD): BOOL; virtual; stdcall; abstract;
    function ProcessBuffer(buffer: Pointer; rowsCount: Integer): BOOL; virtual; stdcall; abstract;
    function GetBuffer(rowsCount: Integer): Pointer; virtual; stdcall; abstract;
    procedure SetError; virtual; stdcall; abstract;
    function GetCancelProcessing: BOOL; virtual; stdcall; abstract;
  end;

  TPluginInterfaceForThumbLoaderAbstract = class
    function LoadThumbnail(filename: PAnsiChar; thumbWidth: Integer; thumbHeight: Integer; thumbMaker: TSalamanderThumbnailMakerAbstract; fastThumbnail: BOOL): BOOL; virtual; stdcall; abstract;
  end;

implementation

end.
