unit spl_xpth;

interface

uses
  Windows,
  CommCtrl,
  CommDlg,
  UxTheme,
  winliblt;

type
  TXpThemeSupportAbstract = class
    function OpenThemeData(hwnd: HWND; pszClassList: LPCWSTR): HTHEME; virtual; stdcall; abstract;
    function CloseThemeData(hTheme: HTHEME): HRESULT; virtual; stdcall; abstract;
    function DrawThemeBackground(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; pRect: PRect; pClipRect: PRect): HRESULT; virtual; stdcall; abstract;
    function DrawThemeText(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; pszText: LPCWSTR; iCharCount: Integer; dwTextFlags: DWORD; dwTextFlags2: DWORD; pRect: PRect): HRESULT; virtual; stdcall; abstract;
    function GetThemeBackgroundContentRect(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; pBoundingRect: PRect; out pContentRect: PRect): HRESULT; virtual; stdcall; abstract;
    function GetThemeBackgroundExtent(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; pContentRect: PRect; out pExtentRect: PRect): HRESULT; virtual; stdcall; abstract;
    function GetThemePartSize(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; prc: PRect; eSize: TThemeSize; out psz: PSize): HRESULT; virtual; stdcall; abstract;
    function GetThemeTextExtent(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; pszText: LPCWSTR; iCharCount: Integer; dwTextFlags: DWORD; pBoundingRect: PRect; out pExtentRect: PRect): HRESULT; virtual; stdcall; abstract;
    function GetThemeTextMetrics(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; ptm: PTextMetric): HRESULT; virtual; stdcall; abstract;
    function GetThemeBackgroundRegion(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; pRect: PRect; out pRegion: PHRGN): HRESULT; virtual; stdcall; abstract;
    function HitTestThemeBackground(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; dwOptions: DWORD; pRect: PRect; hrgn: HRGN; ptTest: TPoint; out pwHitTestCode: PWORD): HRESULT; virtual; stdcall; abstract;
    function DrawThemeEdge(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; pDestRect: PRect; uEdge: UINT; uFlags: UINT; out pContentRect: PRect): HRESULT; virtual; stdcall; abstract;
    function DrawThemeIcon(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; pRect: PRect; himl: HIMAGELIST; iImageIndex: Integer): HRESULT; virtual; stdcall; abstract;
    function IsThemePartDefined(hTheme: HTHEME; iPartId: Integer; iStateId: Integer): BOOL; virtual; stdcall; abstract;
    function IsThemeBackgroundPartiallyTransparent(hTheme: HTHEME; iPartId: Integer; iStateId: Integer): BOOL; virtual; stdcall; abstract;
    function GetThemeColor(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pColor: PColorRef): HRESULT; virtual; stdcall; abstract;
    function GetThemeMetric(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; iPropId: Integer; out piVal: PInteger): HRESULT; virtual; stdcall; abstract;
    function GetThemeString(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pszBuff: LPWSTR; cchMaxBuffChars: Integer): HRESULT; virtual; stdcall; abstract;
    function GetThemeBool(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pfVal: PBOOL): HRESULT; virtual; stdcall; abstract;
    function GetThemeInt(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out piVal: PInteger): HRESULT; virtual; stdcall; abstract;
    function GetThemeEnumValue(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out piVal: PInteger): HRESULT; virtual; stdcall; abstract;
    function GetThemePosition(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pPoint: PPoint): HRESULT; virtual; stdcall; abstract;
    function GetThemeFont(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pFont: PLogFont): HRESULT; virtual; stdcall; abstract;
    function GetThemeRect(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pRect: PRect): HRESULT; virtual; stdcall; abstract;
    function GetThemeMargins(hTheme: HTHEME; hdc: HDC; iPartId: Integer; iStateId: Integer; iPropId: Integer; prc: PRect; out pMargins: PMargins): HRESULT; virtual; stdcall; abstract;
    function GetThemeIntList(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pIntList: PIntList): HRESULT; virtual; stdcall; abstract;
    function GetThemePropertyOrigin(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pOrigin: PPropertyOrigin): HRESULT; virtual; stdcall; abstract;
    function SetWindowTheme(hwnd: HWND; pszSubAppName: LPCWSTR; pszSubIdList: LPCWSTR): HRESULT; virtual; stdcall; abstract;
    function GetThemeFilename(hTheme: HTHEME; iPartId: Integer; iStateId: Integer; iPropId: Integer; out pszThemeFileName: LPWSTR; cchMaxBuffChars: Integer): HRESULT; virtual; stdcall; abstract;
    function GetThemeSysColor(hTheme: HTHEME; iColorId: Integer): TColorRef; virtual; stdcall; abstract;
    function GetThemeSysColorBrush(hTheme: HTHEME; iColorId: Integer): HBRUSH; virtual; stdcall; abstract;
    function GetThemeSysBool(hTheme: HTHEME; iBoolId: Integer): BOOL; virtual; stdcall; abstract;
    function GetThemeSysSize(hTheme: HTHEME; iSizeId: Integer): Integer; virtual; stdcall; abstract;
    function GetThemeSysFont(hTheme: HTHEME; iFontId: Integer; out plf: PLogFont): HRESULT; virtual; stdcall; abstract;
    function GetThemeSysString(hTheme: HTHEME; iStringId: Integer; out pszStringBuff: LPWSTR; cchMaxStringChars: Integer): HRESULT; virtual; stdcall; abstract;
    function GetThemeSysInt(hTheme: HTHEME; iIntId: Integer; piValue: PInteger): HRESULT; virtual; stdcall; abstract;
    function IsThemeActive: BOOL; virtual; stdcall; abstract;
    function IsAppThemed: BOOL; virtual; stdcall; abstract;
    function GetWindowTheme(hwnd: HWND): HTHEME; virtual; stdcall; abstract;
    function EnableThemeDialogTexture(hwnd: HWND; dwFlags: DWORD): HRESULT; virtual; stdcall; abstract;
    function IsThemeDialogTextureEnabled(hwnd: HWND): BOOL; virtual; stdcall; abstract;
    function GetThemeAppProperties: DWORD; virtual; stdcall; abstract;
    procedure SetThemeAppProperties(dwFlags: DWORD); virtual; stdcall; abstract;
    function GetCurrentThemeName(out pszThemeFileName: LPWSTR; cchMaxNameChars: Integer; out pszColorBuff: LPWSTR; cchMaxColorChars: Integer; out pszSizeBuff: LPWSTR; cchMaxSizeChars: Integer): HRESULT; virtual; stdcall; abstract;
    function GetThemeDocumentationProperty(pszThemeName: LPCWSTR; pszPropertyName: LPCWSTR; out pszValueBuff: LPWSTR; cchMaxValChars: Integer): HRESULT; virtual; stdcall; abstract;
    function DrawThemeParentBackground(hwnd: HWND; hdc: HDC; prc: PRect): HRESULT; virtual; stdcall; abstract;
    function EnableTheming(fEnable: BOOL): HRESULT; virtual; stdcall; abstract;
  end;

implementation

end.
