unit spl_zlib;

interface

uses
  Windows,
  spl_com;

const
  SAL_Z_NO_FLUSH = 0;
  SAL_Z_SYNC_FLUSH = 2;
  SAL_Z_FULL_FLUSH = 3;
  SAL_Z_FINISH = 4;
  SAL_Z_BLOCK = 5;

  SAL_Z_OK = 0;
  SAL_Z_STREAM_END = 1;
  SAL_Z_NEED_DICT = 2;
  SAL_Z_ERRNO = -1;
  SAL_Z_STREAM_ERROR = -2;
  SAL_Z_DATA_ERROR = -3;
  SAL_Z_MEM_ERROR = -4;
  SAL_Z_BUF_ERROR = -5;
  SAL_Z_VERSION_ERROR = -6;

type
  TSalZLIB = packed record
    next_in: PBYTE;
    avail_in: UINT;
    total_in: ULONG;
    next_out: PBYTE;
    avail_out: UINT;
    total_out: ULONG;
  end;
  PSalZLIB = ^TSalZLIB;

  TSalamanderZLIBAbstract = class
    function DeflateInit(zlibInfo: PSalZLIB; compressLevel: Integer): Integer; virtual; stdcall; abstract;
    function Deflate(zlibInfo: PSalZLIB; flush: Integer): Integer; virtual; stdcall; abstract;
    function DeflateEnd(zlibInfo: PSalZLIB): Integer; virtual; stdcall; abstract;
    function InflateInit(zlibInfo: PSalZLIB): Integer; virtual; stdcall; abstract;
    function Inflate(zlibInfo: PSalZLIB; flush: Integer): Integer; virtual; stdcall; abstract;
    function InflateEnd(zlibInfo: PSalZLIB): Integer; virtual; stdcall; abstract;
    function InflateInit2(zlibInfo: PSalZLIB; windowBits: Integer): Integer; virtual; stdcall; abstract;
    function InflateInit2_P(zlibInfo: PSalZLIB; windowBits: Integer): Integer; virtual; stdcall;
  end;

implementation

function TSalamanderZLIBAbstract.InflateInit2_P(zlibInfo: PSalZLIB; windowBits: Integer): Integer;
begin
  Result := InflateInit2(zlibInfo, windowBits);
end;

end.
